import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.layout.GridPane;
import javafx.scene.shape.Rectangle;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.event.EventHandler;
import javafx.scene.input.MouseEvent;

public class GUIEksempel extends Application {
	
	final int ROWS = 10;
	final int COLS = 20;
	final int RECTSZ = 20;
	
	public void start(Stage stage) {

		GridPane grid = new GridPane();
		EventHandler handler = new RectHandler();
		for (int i = 0; i < ROWS; i++) {
			for (int j = 0; j < COLS; j++) {
				Rectangle r = new Rectangle (RECTSZ, RECTSZ, Color.WHITE);
				r.setStroke(Color.BLACK);
				r.setOnMouseClicked(handler);
				grid.add(r, j, i);
			}
		}
		
		
		Scene scene = new Scene(grid);
		stage.setScene(scene);
		stage.show();
	}
	
	class RectHandler implements EventHandler<MouseEvent> {
		public void handle(MouseEvent e) {
			Rectangle r = (Rectangle) e.getSource();
			r.setFill(Color.RED);
		}
	}
}