import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.Scene;
import javafx.event.EventHandler;
import javafx.scene.input.MouseEvent;
import javafx.event.ActionEvent;
import javafx.scene.control.Button;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import java.nio.file.Paths;
import javafx.geometry.Pos;
import javafx.stage.FileChooser;
import javafx.stage.FileChooser.ExtensionFilter;
import java.io.File;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;

public class Player extends Application {
	
	//Bytt ut med egen lokal adresse!
	Media media = new Media("file:///D:/Dev/Rep_bk/paris.mp3");
	MediaPlayer mediaPlayer = new MediaPlayer(media);
	
	Button playBtn = null;
	Button stopBtn = null;
	
	boolean playing = false;
	
	public void start(Stage stage) {
		

		VBox root = new VBox();
		root.setAlignment(Pos.CENTER);
		
		
		//Play buttons
		HBox controlPane = new HBox();
		controlPane.setAlignment(Pos.CENTER);
		
		playBtn = new Button("Play");
		playBtn.setOnAction(new PlayHandler());
		
		stopBtn = new Button("Stop");
		stopBtn.setOnAction(new StopHandler());
		//controlPane.getChildren().addAll(playBtn, stopBtn);
		
		
		//Morsommere alternativ:	
		//Knappene blir Image/ImageView.
		
		Image playImg = new Image("play.png");
		Image pauseImg = new Image("pause.png");
		Image stopImg = new Image("stop.png");
		
		ImageView playPauseIcon = new ImageView(playImg);
		playPauseIcon.setFitWidth(200);
		playPauseIcon.setFitHeight(200);
		
		ImageView stopIcon = new ImageView(stopImg);
		stopIcon.setFitWidth(200);
		stopIcon.setFitHeight(200);
		
		
		playPauseIcon.setOnMouseClicked(new EventHandler<MouseEvent> () {
			public void handle(MouseEvent e) {
				if (playing) {
				mediaPlayer.pause();
				setPlay(false);
				playPauseIcon.setImage(playImg);
				
			} else {
				mediaPlayer.play();
				setPlay(true);
				playPauseIcon.setImage(pauseImg);
			}
			}
		});
		
		stopIcon.setOnMouseClicked(new EventHandler<MouseEvent> () {
			public void handle(MouseEvent e) {
				mediaPlayer.stop();
				setPlay(false);
				playPauseIcon.setImage(playImg);
			}
		});
		
		//MERK: Transparente piksler trigger ikke onMouseClicked.
		controlPane.getChildren().addAll(playPauseIcon, stopIcon);
		
		
		
		//Filvelger
		Button fileBtn = new Button("Open file");
		fileBtn.setOnAction(new OpenFile(stage));
		
		//Alternativ med anonym klasse
		/*fileBtn.setOnAction(new EventHandler<ActionEvent>() {
			public void handle(ActionEvent e) {
					FileChooser fc = new FileChooser();
					fc.setTitle("Open music file ...");
					fc.getExtensionFilters().add(new ExtensionFilter("Music files", "*.wav", "*.mp3", "*.ogg"));
					File filen = fc.showOpenDialog(stage);
					
					if (filen != null) {
						String uri = filen.toURI().toString();
						mediaPlayer.stop();
						mediaPlayer = new MediaPlayer(new Media(uri));
						setPlay(false);
					}
				}
		});*/
		
		
		
		
		//Legger elementer til rotnoden
		root.getChildren().add(fileBtn);
		root.getChildren().add(controlPane);
		
		//Presentasjon
		Scene scene = new Scene(root);
		stage.setScene(scene);
		stage.show();
	}
	
	class PlayHandler implements EventHandler<ActionEvent> {
		
		@Override
		public void handle(ActionEvent e) {
			
			Button b = (Button) e.getSource();
			
			if (playing) {
				mediaPlayer.pause();
				setPlay(false);
				
			} else {
				mediaPlayer.play();
				setPlay(true);
			}
		}
	}
	
	class StopHandler implements EventHandler<ActionEvent> {
		
		@Override 
		public void handle(ActionEvent e) {
			mediaPlayer.stop();
			setPlay(false);
		}
	}
	
	void setPlay(boolean val) {
		playing = val;
		if (playing) {
			playBtn.setText("Pause");
		} else {
			playBtn.setText("Play");
		}
	}
	
	
	
	class OpenFile implements EventHandler<ActionEvent>{
		
			Stage stage;
		
			public OpenFile(Stage s) {
				this.stage = s;
			}
		
			public void handle(ActionEvent e) {
					FileChooser fc = new FileChooser();
					fc.setTitle("Open music file ...");
					fc.getExtensionFilters().add(new ExtensionFilter("Music files", "*.wav", "*.mp3", "*.ogg"));
					File filen = fc.showOpenDialog(stage);
					
					if (filen != null) {
						String uri = filen.toURI().toString();
						mediaPlayer.stop();
						mediaPlayer = new MediaPlayer(new Media(uri));
						setPlay(false);
					}
				}
		}
	
	
	
	

}